#include "SoundMapDlg.h"
#include <qlabel.h>
#include <qkeycode.h>
#include <qapplication.h>
#include "mapParser.h"
#include "common.h"

CSoundMapDlg::CSoundMapDlg(QWidget *parent) : QDialog(parent, "SoundMap", TRUE, 0),
                                              m_viewBack(this, "ViewBackground"),
                                              m_view(&m_viewBack, "ScrollMap", 0),
                                              m_panel(&m_view),
                                              m_label("Press <Esc> to close this window", this)
{
	QSize    sz ;
	int      x, y, w, h ;

	setCaption("Display sound maps ...") ;

	m_viewBack.move(4, 4) ;
	m_view.move(2, 2) ;
	m_view.addChild(&m_panel, -1, -1) ;

	m_panel.GetDimension(sz) ;
	m_panel.resize(sz) ;

	if (sz.width() > (3*gScrnWidth/4))
		w = 3*gScrnWidth/4 ;
	else
		w = sz.width() ;

	if (sz.height() > (3*gScrnHeight/4))
		h = 3*gScrnHeight/4 ;
	else
		h = sz.height() ;

	m_viewBack.resize(w+2, h+2) ;
	m_view.resize(w, h) ;

	m_viewBack.setFrameStyle(QFrame::WinPanel | QFrame::Sunken) ;

	setFixedSize(w+14, h+35) ;

	m_label.move(4, h+10) ;
	m_label.resize(w, 20) ;
	m_label.setAlignment(AlignRight | AlignVCenter) ;

	x = (QApplication::desktop()->width() - width())/2 ;
	y = (QApplication::desktop()->height() - height())/2 ;

	if (x < 0)
		x = 0 ;
	if (y < 0)
		y = 0 ;

	move(x, y) ;
}

void CSoundMapDlg::keyPressEvent(QKeyEvent *key)
{
	int    dx = m_panel.m_w2/2 ;
	int    dy = m_panel.m_lineHeight/2 ;

	switch (key->key())
	{
	case Key_Escape:
		done(0) ;
		break ;
	case Key_Down:
		m_view.scrollBy(0, dy) ;
		break ;
	case Key_Up:
		m_view.scrollBy(0, -dy) ;
		break ;
	case Key_Right:
		m_view.scrollBy(dx, 0) ;
		break ;
	case Key_Left:
		m_view.scrollBy(-dx, 0) ;
		break ;
	}
}


