/***************************************************************************
                          kiwritedoc.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Oct  8 19:11:34 PDT 1999
                                           
    copyright            : (C) 1999 by Subhabrata Biswas                         
    email                : subhabrata.biswas@usa.net                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include <kiwritedoc.h>
#include <kmsgbox.h>
#include <kfiledialog.h>

KIWriteDoc::KIWriteDoc(QObject *parent, const char *filename):QObject(parent){
}

KIWriteDoc::~KIWriteDoc(){
}

bool KIWriteDoc::saveContents(KEdit *edit)
{
	int   stat ;
	
	if (edit->getName().isNull())
	{
		QString    file = KFileDialog::getSaveFileName(NULL, "*.ind", edit, "KEdit.SaveName") ;
		
		if (file.isNull())
			return false ;
			
		stat = edit->doSave(file) ;
	}
	else
		stat = edit->doSave() ;
	
	if (stat)
		return false ;
	else
		return true ;
}

bool KIWriteDoc::loadContents(KEdit *edit)
{
	int stat ;

	if (!closeFile(edit))
		return false ;

	edit->openFile(KEdit::OPEN_READWRITE) ;

	if (stat)
		return false ;
	else
		return true ;
}

bool KIWriteDoc::closeFile(KEdit *edit)
{
	if (!askAndSave(edit))
		return false ;

	edit->newFile() ;
	
	return true ;
}

bool KIWriteDoc::askAndSave(KEdit *edit)
{
	int   ret ;

	if (edit->isModified())
	{
		ret = KMsgBox::yesNoCancel(edit, "Document modified", "You have made changes in the current document but did not save it. Do you want to save it now ?", KMsgBox::QUESTION) ;
		if (ret == 1)
			return saveContents(edit) ;
		if (ret == 2)
			return true ;
		if (ret == 3)
			return false ;
	}
	
	return true ;
}

bool KIWriteDoc::saveAs(KEdit *edit)
{
	QString   file ;

	file = KFileDialog::getSaveFileName(NULL, "*.ind", edit, "KEdit.SaveName") ;
	if (file.isNull())
		return false ;

	return edit->doSave(file) == 0 ;
}




