/***************************************************************************
                          kiwriteview.h  -  description                              
                             -------------------                                         
    begin                : Fri Oct  8 19:11:34 PDT 1999
                                           
    copyright            : (C) 1999 by Subhabrata Biswas                         
    email                : subhabrata.biswas@usa.net                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KIWRITEVIEW_H 
#define KIWRITEVIEW_H 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <kapp.h>
#include <qwidget.h>
#include <ktabctl.h>
#include <keditcl.h>
#include <qpainter.h>
#include "kiwritedoc.h"
/**
  * This class provides an incomplete base for your application view. 
   */

class KIWriteView : public QWidget
{
  Q_OBJECT

 public:
  /** Constructor for the main view */
  KIWriteView(KApplication* a=0,KIWriteDoc* doc=0,QWidget *parent = 0);
  /** Destructor for the main view */
  ~KIWriteView();

  KTabCtl     m_tab ;
  KEdit       m_ind ;
  KEdit       m_eng ;

  KEdit      &CurrentView() ;
 private:
	int        m_currTab ;
 protected:
 	KIWriteDoc *m_doc ;
 	virtual void resizeEvent(QResizeEvent *) ;
 	
 public slots:
 	void loadFile() ;
 	void saveFile() ;
 	void saveAs() ;
 	void closeFile() ;
 	void newFile() ;
 	void tabSelected(int i) ;
 	void fontChanged() ;
 	void print(QPainter &paint) ;
 	void editCut() ;
 	void editCopy() ;
 	void editPaste() ;
 	void editSelectAll() ;
};

#endif // KIWRITEVIEW_H













