// MapParser.h: interface for the CMapParser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAPPARSER_H__AF6F1F63_B9C2_11D2_8422_0060B0A16AAA__INCLUDED_)
#define AFX_MAPPARSER_H__AF6F1F63_B9C2_11D2_8422_0060B0A16AAA__INCLUDED_

#include <qstring.h>

#define   MAP_GROW_SIZE      25

typedef enum {ScanNoData, ScanDataFound, ScanError} ScanRetType ;
typedef enum {Vowel, Cons, StandAlone} Type ;
typedef enum {None, Pre, Post, Both, Around, AroundPost} Side ;

typedef struct _tagMapType
{
	char     eng[10] ;
	char     bong_cons[10] ;
	char     bong_vow[10] ;
	Type     type ;
	Side     side ;
} MapType ;

extern int         nMaps ;
extern MapType    *pMaps ;

class CMapParser  
{
public:
	bool ReadToken(char *sSrcText, char *sDestText, int nSrcLen, int *index);
	ScanRetType CMapParser::ScanLine(char *sSrcLine, char *sOrgText, char *sReplText,
												char *sApplyText, Type *type, Side *side, char *sError) ;
	bool ParseMapFile(const char * sMapFile, QString &errMsg);
	CMapParser();
	virtual ~CMapParser();

	static void AddMap(MapType *map) ;
	static void ResetMap() ;

private:
	void SkipSpace(char *ptr, int len, int *index);
};

#endif // !defined(AFX_MAPPARSER_H__AF6F1F63_B9C2_11D2_8422_0060B0A16AAA__INCLUDED_)

